releases/20170422152552/releases/20170420035837/releases/20170420005029/config/routes.rb
Rails.application.routes.draw do

  # Authentication
  get 'auth/:provider/callback', to: 'sessions#create'
  get 'auth/failure', to: redirect('/')
  get 'signout', to: 'sessions#destroy', as: 'signout'
  resources :sessions, only: [:create, :destroy]

  # Homepages
  root 'home#logged_in'
  get 'authenticate', to: 'home#logged_out'
  resource :home, only: [:logged_in, :logged_out]

  # Admin
  get :admin, to: 'admin#home'

  # Users
  resources :users do
    put :organization_enable, :organization_disable
  end

  # User roles
  resources :user_roles

  # Roles
  resources :roles

  # Organizations
  resources :organizations

  # Late Plates
  resources :late_plates

  # Meals
  resources :meals

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

releases/20170422152552/releases/20170420035837/releases/20170420005029/app/models/meal.rb
# == Schema Information
#
# Table name: meals
#
#  id              :integer          not null, primary key
#  name            :string           not null
#  time            :time             not null
#  organization_id :integer
#  created_at      :datetime         not null
#  updated_at      :datetime         not null
#

class Meal < ApplicationRecord
  has_many :late_plates

  # Validation
  validates :name, presence: true
  validates :time, presence: true

  def meal_name
    "#{name} at #{short_time}"
  end

  def short_time
    time.strftime("%I:%M %p")
  end
end

releases/20170422152552/releases/20170420035837/releases/20170420005029/app/controllers/meals_controller.rb
class MealsController < ApplicationController
  before_action :authorize_action

  def new
    @meal = Meal.new
  end

  def edit
    @meal = Meal.find(params[:id])
  end

  def create
    @meal = Meal.new(meal_params)

    if current_user
      @meal.organization_id = current_user.affiliated_organization
    end

    if @meal.save
      redirect_to action: "index"
    else
      render 'new'
    end
  end

  def update
    @meal = Meal.find(params[:id])

    if @meal.update(meal_params)
      redirect_to action: "index"
    else
      render 'edit'
    end
  end

  def index
    @meals = policy_scope(Meal).where(organization_id: current_user.affiliated_organization)
  end

  def show
    @meal = Meal.find(params[:id])
  end

  def destroy
    Meal.find(params[:id]).delete

    redirect_to meals_path
  end

  private

  def meal_params
    params.require(:meal).permit(
      :name,
      :time,
      :organization_id
    )
  end

  def authorize_action
    authorize Meal
  end
end

releases/20170422152552/releases/20170420035837/releases/20170420005029/app/helpers/meals_helper.rb
module MealsHelper
end

releases/20170422152552/releases/20170420035837/releases/20170420005029/app/views/meals/_form.html.erb
<%= form_for @meal do |f| %>
  <% if @meal.errors.any? %>
    <div id="error_explanation">
      <h2>
        <%= pluralize(@meal.errors.count, "error") %> prohibited
        this meal time from being saved:
      </h2>
      <ul>
        <% @meal.errors.full_messages.each do |msg| %>
          <li><%= msg %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="form-group">
    <%= f.label :name %>
    <%= f.text_field :name, class: 'form-control' %>
  </div>

  <div class="form-group">
    <%= f.label :time %>
    <div class="input-group">
    <%= f.text_field :time, :id => "datepicker", :value => Time.now.strftime("%l:%M %p"), :class=>'form-control' %>
    <span class="input-group-addon"><span class="glyphicon glyphicon-time"></span></span>
  </div>
  </br>
  <div>
    <%= f.submit 'Submit', :class => 'btn btn-default' %>
  </div>
<% end %>

<script>
$('#datepicker').datetimepicker({format: 'LT'});
</script>

releases/20170422152552/releases/20170420035837/releases/20170420005029/app/views/meals/edit.html.erb
<%= render 'layouts/header' %>

<div class="container theme-showcase">
  <h1>Editing Meal Time</h1>
    <%= render 'form' %>
</div>

<%= render 'layouts/footer' %>

releases/20170422152552/releases/20170420035837/releases/20170420005029/app/views/meals/index.html.erb
<%= render 'layouts/header' %>

<div class="container theme-showcase">
  <div style="text-align:left;">
    <h1>
      Meals
      <span style="float:right;">
        <%= link_to "Create a new meal time", new_meal_path(), :class => "btn btn-primary" %>
      </span>
    </h1>
    <table class="table">
      <tr>
        <th>Name</th>
        <th>Time</th>
        <th>Actions</th>
      </tr>
      <% @meals.each do |meal| %>
      <tr>
        <td><%= meal.name %></td>
        <td><%= meal.time.strftime("%l:%M %p") %></td>
        <td class="btn-group" role="group" aria-label="...">
          <%= link_to "Edit", edit_meal_path(meal), :class => "btn btn-success" %>
          <%= link_to "Delete", meal_path(meal),  method: :delete, :class => "btn btn-danger", data: { confirm: 'Delete meal time?' } %>
        </td>
      </tr>
      <% end %>
    </table>
  </div>
</div>

<%= render 'layouts/footer' %>

releases/20170422152552/releases/20170420035837/releases/20170420005029/app/views/meals/new.html.erb
<%= render 'layouts/header' %>

<div class="container theme-showcase">
  <h1>New Meal Time
    <span style="float:right;">
      <%= link_to "Back to Meal Times", meals_path(), :class => "btn btn-primary" %>
    </span>
  </h1>
  <%= render 'form' %>
</div>

<%= render 'layouts/footer' %>